                 LIST P=16F628
                 __CONFIG H'3F70'
W                EQU             0
F                EQU             1
STATUS           EQU             03H
PORTB            EQU             06H
INTCON           EQU             0BH
PIR1             EQU             0CH
CMCON            EQU             1FH
OPTION_REG       EQU             01H
TRISB            EQU             06H
PCON             EQU             0EH
VRCON            EQU             1FH
RP0              EQU             5
GIE              EQU             7
T0IE             EQU             5
T0IF             EQU             2
OSCF             EQU             3
RBIF             EQU             0
CMIF             EQU             6
C1OUT            EQU             6
;

COUNT2           EQU             21H
OUT              EQU             23H
W_TMP            EQU             24H
STATUS_TMP       EQU             25H
;
                 ORG             0
                 GOTO            INIT
                 ORG             4
                 GOTO            TIME
INIT             BSF             STATUS,RP0
                 BCF             PCON,OSCF                  ;  32 
                 BCF             TRISB,0
                 BCF             TRISB,1
                 MOVLW           H'C2'
                 MOVWF           OPTION_REG
                 MOVLW           H'A6'
                 MOVWF           VRCON
                 BCF             STATUS,RP0
                 MOVLW           H'12'
                 MOVWF           CMCON
                 MOVLW           H'A0'
                 MOVWF           COUNT2                     ;  (40 )
                 CLRF            OUT
                 MOVF            PORTB,W
                 BCF             INTCON,RBIF
                 BCF             PIR1,CMIF
                 BSF             INTCON,T0IE
                 BSF             INTCON,GIE
START            MOVF            OUT,W
                 MOVWF           PORTB
                 NOP
                 NOP
                 NOP
                 GOTO            START
TIME             BCF             INTCON,GIE               
                 MOVWF           W_TMP                    ; 
                 SWAPF           STATUS,W
                 BCF             STATUS,RP0
                 MOVWF           STATUS_TMP
                 BCF             INTCON,T0IF
                 BTFSC           INTCON,RBIF
                 GOTO            WORK
                 BTFSC           PIR1,CMIF
                 GOTO            WORK
                 GOTO            ENDTIME
WORK             MOVF            PORTB,W
                 MOVF            CMCON,W
                 BTFSS           CMCON,C1OUT
                 GOTO            M1
                 BTFSC           PORTB,6
                 CALL            LAMP_ON
                 BTFSS           PORTB,6
                 CALL            RESTORE
                 GOTO            ENDTIME
M1               BTFSS           PORTB,6
                 CALL            LAMP_OFF
                 BTFSC           PORTB,6
                 CALL            RESTORE
ENDTIME          SWAPF           STATUS_TMP,W             ; 
                 MOVWF           STATUS
                 SWAPF           W_TMP,F
                 SWAPF           W_TMP,W
                 RETFIE
LAMP_ON          MOVLW           H'A0'                    ; 
                 MOVWF           COUNT2                   ; 
                 BTFSC           CMCON,C1OUT
                 BSF             OUT,1
                 BCF             INTCON,RBIF
                 BCF             PIR1,CMIF
                 RETURN
LAMP_OFF         DECFSZ          COUNT2,F                 ; 
                 RETURN
                 MOVLW           H'A0'
                 MOVWF           COUNT2                   ; 
                 BTFSS           CMCON,C1OUT
                 BCF             OUT,1
                 BCF             INTCON,RBIF
                 BCF             PIR1,CMIF
                 RETURN
RESTORE          BCF             INTCON,RBIF              ;  
                 BCF             PIR1,CMIF
                 MOVLW           H'A0'
                 MOVWF           COUNT2
                 RETURN
                 END
                 
